=== debian/changelog ===
spfft (0.9.9-1) unstable; urgency=medium

  * Initial release (Closes: #945813)

 -- Andrius Merkys <merkys@debian.org>  Thu, 28 Nov 2019 04:54:07 -0500
