=== debian/changelog ===
spfft (0.9.10-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:07 +0100

spfft (0.9.10-1) unstable; urgency=medium

  * New upstream version 0.9.10
  * Removing upstream-integrated patch.
  * Adding 'Rules-Requires-Root: no'.

 -- Andrius Merkys <merkys@debian.org>  Fri, 27 Dec 2019 01:16:10 -0500
