=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  libfftw3-dev,
  mpi-default-dev,
 Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft
 Vcs-Git: https://salsa.debian.org/science-team/spfft.git
