## spfft 0.9.11

=== debian/changelog ===
spfft (0.9.11-1) unstable; urgency=medium

  * New upstream version 0.9.11
  * Refreshing remove-badges.patch.
  * Fixing a typo in package description.

 -- Andrius Merkys <merkys@debian.org>  Tue, 30 Jun 2020 01:09:29 -0400
