## spfft 0.9.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
-project(SpFFT LANGUAGES CXX VERSION 0.9.10)
+project(SpFFT LANGUAGES CXX VERSION 0.9.12)
 set(SPFFT_SO_VERSION 0)
 set(SPFFT_VERSION ${PROJECT_VERSION})
 
@@ -110,10 +110,15 @@
 
 # ROCM
 if(SPFFT_ROCM)
-	find_package(ROCM REQUIRED COMPONENTS rocfft)
-	list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${ROCM_INCLUDE_DIRS})
-	list(APPEND SPFFT_EXTERNAL_LIBS ${ROCM_LIBRARIES})
-	list(APPEND SPFFT_EXTERNAL_COMPILE_OPTIONS ${ROCM_DEFINITIONS})
+	if(NOT HIP_HCC_FLAGS)
+		message(STATUS "Using default AMD gpu targets: gfx803, gfx900, gfx906. Set HIP_HCC_FLAGS to override.")
+		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
+	endif()
+	find_package(HIP REQUIRED)
+	find_package(HIPLIBS REQUIRED)
+	find_package(ROCFFT REQUIRED)
+	list(APPEND SPFFT_EXTERNAL_LIBS HIPLIBS::hiplibs ROCFFT::rocfft)
+	list(APPEND SPFFT_EXTERNAL_COMPILE_OPTIONS -D__HIP_PLATFORM_HCC__) # required for parsing HIP headers with another compiler
 endif()
