=== debian/changelog ===
spfft (0.9.12-1) unstable; urgency=medium

  * New upstream version 0.9.12
  * Updating copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 03 Aug 2020 03:13:30 -0400
