## spfft 0.9.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
-project(SpFFT LANGUAGES CXX VERSION 0.9.12)
+project(SpFFT LANGUAGES CXX VERSION 0.9.13)
 set(SPFFT_SO_VERSION 0)
 set(SPFFT_VERSION ${PROJECT_VERSION})
