=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 	spfft/multi_transform.cpp
 	spfft/grid.cpp
 	spfft/grid_internal.cpp
+	fft/fftw_mutex.cpp
 	)
 
 if(SPFFT_SINGLE_PRECISION)
@@ -39,16 +40,7 @@
 			transpose/transpose_mpi_unbuffered_gpu.cpp
 			)
 	endif()
-endif()
-
-if(SPFFT_CUDA)
 	list(APPEND SPFFT_SOURCE_FILES ${SPFFT_GPU_KERNELS})
-endif()
-
-if(SPFFT_ROCM)
-	rocm_generate_objects(ROCM_OBJECTS ROCM_TARGETS ${SPFFT_GPU_KERNELS} INCLUDE_DIRS ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS}
-		FLAGS -fPIC  -fno-gpu-rdc --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
-	list(APPEND SPFFT_SOURCE_FILES ${ROCM_OBJECTS})
 endif()
 
 if(SPFFT_MPI)
@@ -59,11 +51,26 @@
 		)
 endif()
 
-add_library(spfft ${SPFFT_LIBRARY_TYPE}
-	${SPFFT_SOURCE_FILES}
-	)
+if(SPFFT_ROCM)
+	set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} -fno-gpu-rdc)
+	set(HIP_HCC_FLAGS_RELEASE ${HIP_HCC_FLAGS_RELEASE} -Wno-everything)
+	if(CMAKE_CXX_STANDARD)
+		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} -std=gnu++${CMAKE_CXX_STANDARD})
+	endif()
+			
+	# macro from FindHIP package, which compiles all .cu files with hipcc and cpp files with the set c++ compiler
+	HIP_ADD_LIBRARY(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+else()
+	add_library(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+endif()
+
 set_property(TARGET spfft PROPERTY VERSION ${SPFFT_VERSION})
 set_property(TARGET spfft PROPERTY SOVERSION ${SPFFT_SO_VERSION})
+# All .cu files are self-contained. Device linking can have issues with propageted linker flags of other targets like MPI.
+if(SPFFT_CUDA)
+	set_property(TARGET spfft PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS OFF)
+	set_property(TARGET spfft PROPERTY CUDA_SEPARABLE_COMPILATION OFF)
+endif()
 
 # build fortran module
 if(SPFFT_FORTRAN)
@@ -77,11 +84,6 @@
 	else()
 		target_link_options(spfft PRIVATE "-Wl,--exclude-libs,ALL")
 	endif()
-endif()
-
-# add depency on ojbect generating targets for ROCM
-if(SPFFT_ROCM)
-	add_dependencies(spfft ${ROCM_TARGETS})
 endif()
 
 # generate export header to control symbol visibility
