=== debian/changelog ===
spfft (0.9.13-1) unstable; urgency=medium

  * New upstream version 0.9.13

 -- Andrius Merkys <merkys@debian.org>  Mon, 24 Aug 2020 02:36:13 -0400
