=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  frequency domain, as required by some computational material science codes.
  For distributed computations, SpFFT uses a slab decomposition in space domain
  and pencil decomposition in frequency domain (all sparse data within a pencil
- must be on one rank). If desired, the libray can be compiled without any
+ must be on one rank). If desired, the library can be compiled without any
  parallelization (MPI, OpenMP, CUDA / ROCm).
  .
  This package contains development files.
@@ -43,5 +43,5 @@
  frequency domain, as required by some computational material science codes.
  For distributed computations, SpFFT uses a slab decomposition in space domain
  and pencil decomposition in frequency domain (all sparse data within a pencil
- must be on one rank). If desired, the libray can be compiled without any
+ must be on one rank). If desired, the library can be compiled without any
  parallelization (MPI, OpenMP, CUDA / ROCm).
