## spfft 1.0.4

=== debian/changelog ===
spfft (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
  * Refreshing remove-badges.patch.

 -- Andrius Merkys <merkys@debian.org>  Mon, 16 Aug 2021 01:58:50 -0400

spfft (1.0.1-1) experimental; urgency=medium

  * New upstream version 1.0.1
  * Removing unneeded debian/ files.
  * Updating copyright years.
  * Bumping debhelper-compat and Standards-Version (no changes).

 -- Andrius Merkys <merkys@debian.org>  Mon, 15 Feb 2021 03:30:39 -0500
