=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
  Andrius Merkys <merkys@debian.org>,
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libfftw3-dev,
  mpi-default-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft
@@ -20,7 +20,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libspfft0 (= ${binary:Version}),
+ libspfft1 (= ${binary:Version}),
  ${misc:Depends},
 Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support (development files)
  SpFFT was originally intended for transforms of data with spherical cutoff in
@@ -32,7 +32,7 @@
  .
  This package contains development files.
 
-Package: libspfft0
+Package: libspfft1
 Architecture: any
 Multi-Arch: same
 Depends:
