## spfft 1.0.5

=== debian/changelog ===
spfft (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5
  * Adding copyright entry for FindHIP CMake files.

 -- Andrius Merkys <merkys@debian.org>  Fri, 05 Nov 2021 08:22:20 -0400
