=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -66,24 +66,19 @@
 
 	# benchmark executable
 	add_executable(benchmark programs/benchmark.cpp)
-	target_link_libraries(benchmark PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-	target_compile_options(benchmark PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+	target_link_libraries(benchmark PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 	target_include_directories(benchmark PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
-
-	# if(SPFFT_CUDA)
-	#     set_property(TARGET main PROPERTY CUDA_SEPARABLE_COMPILATION ON)
-	# endif()
 
 	# test executables
 	add_executable(run_local_tests
 		run_local_tests.cpp
 		local_tests/test_host_array.cpp
 		local_tests/test_disjoint.cpp
+		local_tests/test_fftw_prop_hash.cpp
 		local_tests/test_local_transform.cpp
 		)
 	target_link_libraries(run_local_tests PRIVATE gtest_main gtest_mpi)
-	target_link_libraries(run_local_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-	target_compile_options(run_local_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+	target_link_libraries(run_local_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 	target_include_directories(run_local_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 
 	if(SPFFT_MPI)
@@ -95,8 +90,7 @@
 			mpi_tests/test_transpose_gpu.cpp
 			)
 		target_link_libraries(run_mpi_tests PRIVATE gtest_main gtest_mpi)
-		target_link_libraries(run_mpi_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-		target_compile_options(run_mpi_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+		target_link_libraries(run_mpi_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 		target_include_directories(run_mpi_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 	endif()
