=== debian/changelog ===
spfft (1.0.6-1) unstable; urgency=medium

  * New upstream version 1.0.6
  * Bumping copyright years.
  * No need to forward remove-badges.patch.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Mon, 21 Feb 2022 03:58:05 -0500
