=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
  libfftw3-dev,
  mpi-default-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft
